
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java并发编程系列之十六：Lock锁 / 憋错料</title>

    <meta name="description" content="Java并发编程系列之十六：Lock锁 Lock锁简介 Lock锁机制是JDK 5之后新增的锁机制,不同于内置锁,Lock锁必须显式声明,并在合适的位置释放锁.Lock是一个接口,其由三个具体的实现:ReentrantLock.ReetrantReadWriteLock.ReadLock 和 ReetrantReadWriteLock.WriteLock,即重入锁.读锁和写锁.增加Lock机制主要是因为内置锁存在一些功能上局限性.比如无法中断一个正在等待获取锁的线程,无法在等待一个锁的时候无限等待下去.内置锁必须在释放锁的代码块中释放">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Java并发编程系列之十六：Lock锁</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>Lock锁简介</strong></p>
<p>Lock锁机制是JDK 5之后新增的锁机制，不同于内置锁，Lock锁必须显式声明，并在合适的位置释放锁。Lock是一个接口，其由三个具体的实现：ReentrantLock、ReetrantReadWriteLock.ReadLock 和 ReetrantReadWriteLock.WriteLock，即重入锁、读锁和写锁。增加Lock机制主要是因为内置锁存在一些功能上局限性。比如无法中断一个正在等待获取锁的线程，无法在等待一个锁的时候无限等待下去。内置锁必须在释放锁的代码块中释放，虽然简化了锁的使用，但是却造成了其他等待获取锁的线程必须依靠阻塞等待的方式获取锁，也就是说内置锁实际上是一种阻塞锁。而新增的Lock锁机制则是一种非阻塞锁（这点后面还会详细介绍）。</p>
<p>首先我们看看Lock接口的源码：</p>
<pre><code>public interface Lock {
    //无条件获取锁
    void lock();
    //获取可响应中断的锁
    //在获取锁的时候可响应中断，中断的时候会抛出中断异常
    void lockInterruptibly() throws InterruptedException;
    //轮询锁。如果不能获得锁，则采用轮询的方式不断尝试获得锁
    boolean tryLock();
    //定时锁。如果不能获得锁，则每隔unit的时间就会尝试重新获取锁
    boolean tryLock(long time, TimeUnit unit) throws InterruptedException;
    //释放获得锁
    void unlock();
    //获取绑定的Lock实例的条件变量。在等待某个条件变量满足的之
    //前，lock实例必须被当前线程持有。调用Condition的await方法
    //会自动释放当前线程持有的锁
    Condition newCondition();</code></pre>
<p>注释写得很详细就不再赘述，可以看出Lock锁机制新增的可响应中断锁和使用公平锁是内置锁机制锁没有的。使用Lock锁的示例代码如下：</p>
<pre><code>Lock lock = new ReentrantLock();
        lock.lock();
        try {
            //更新对象状态
            //如果有异常则捕获异常
            //必要时恢复不变性条件
            //如果由return语句必须放在这里
        }finally {
            lock.unlock();
        }</code></pre>
<p><strong>ReentrantLock与synchronized实现策略的比较</strong></p>
<p>前面的文章有提到synchronized使用的是互斥锁机制，这种同步机制的最大问题在于当由多个线程需要获取通一把锁的时候只能通过阻塞同步的方式等待已经获得锁的线程自动释放锁。这个过程涉及线程的阻塞和线程的唤醒，这个过程需要在操作系统从用户态切换到内核态完成。那么问题来了，多个线程竞争同一把锁的时候，会引起CPU频繁的上下文切换，效率很低，系统开销也很大。这种策略被称为悲观并发策略，也是synchronized使用的并发策略。</p>
<p>ReentrantLock使用了更为先进的并发策略，既然互斥同步造成的阻塞会影响系统的性能，有没有一种办法不用阻塞也能实现同步呢？并发大师Doug Lea（也是Lock锁的作者）提出了以自旋的方式获得锁。简单来说，如果需要获得锁不存在争用的情况，那么获取成功；如果锁存在争用的情况，那么使用失败补偿措施（jdk 5之后到目前的jdk 8使用的是不断尝试重新获取，直到获取成功）解决争用的矛盾。由于自旋发生在线程内部，所以不用阻塞其他的线程，也就是实现了非阻塞同步。这种策略也称为基于冲突检测的乐观并发策略，也是ReentrantLock使用的并发策略。</p>
<p>简单总结ReentrantLock和synchronized，前者的先进性体现在以下几点：</p>
<ol>
<li>可响应中断的锁。当在等待锁的线程如果长期得不到锁，那么可以选择不继续等待而去处理其他事情，而synchronized的互斥锁则必须阻塞等待，不能被中断</li>
<li>可实现公平锁。所谓公平锁指的是多个线程在等待锁的时候必须按照线程申请锁的时间排队等待，而非公平性锁则保证这点，每个线程都有获得锁的机会。synchronized的锁和ReentrantLock使用的默认锁都是非公平性锁，但是ReentrantLock支持公平性的锁，在构造函数中传入一个boolean变量指定为true实现的就是公平性锁。不过一般而言，使用非公平性锁的性能优于使用公平性锁</li>
<li>每个synchronized只能支持绑定一个条件变量，这里的条件变量是指线程执行等待或者通知的条件，而ReentrantLock支持绑定多个条件变量，通过调用lock.newCondition()可获取多个条件变量。不过使用多少个条件变量需要依据具体情况确定。</li>
</ol>
<p><strong>如何在ReentrantLock和synchronized之间进行选择</strong></p>
<blockquote><p>在一些内置锁无法满足一些高级功能的时候才考虑使用ReentrantLock。这些高级功能包括：可定时的、可轮询的与可中断的锁获取操作，公平队列，以及非块结构的锁。否则还是应该优先使用synchronized。</p></blockquote>
<p>这段话是并发大师Brian Goetz的建议。那么，我们来分析一下，为什么在ReentrantLock具有那么多优势的前提下仍然建议优先使用synchronized呢？</p>
<p>首先，内置锁被开发人员锁熟悉（这个理由当然不足以让人信服），而且内置锁的优势在于避免了手动释放锁这一操作。如果在使用ReentrantLock的时候忘记在finally调用unlock了，那么就相当于埋下了一颗定时炸弹，并且影响其他代码的执行（还不够有说服力）。其次，使用内置锁dump线程信息可以帮助分析哪些调用帧获得了哪些锁，并且能够帮助检测和识别发生死锁的线程。这点是ReentrantLock无法做到的（有那么一点说服力了）。最后，synchronized未来还将继续优化，目前的synchronized已经进行了自适应、自旋、锁消除、锁粗化、轻量级锁和偏向锁等方面的优化，在线程阻塞和线程唤醒方面的性能已经没有那么大了。另一方面，ReentrantLock的性能可能就止步于此，未来优化的可能性很小（好吧，我认了）。这点主要是由于synchronized是JVM的内置属性，执行synchronized优化自然顺理成章（嘿嘿，毕竟是亲儿子嘛）。</p>
<p><strong>使用可中断锁</strong></p>
<p>可中断锁的使用示例如下：</p>
<pre><code>    ReentrantLock lock = new ReentrantLock();
    ...........
    lock.lockInterruptibly();//获取响应中断锁
    try {
        //更新对象的状态
        //捕获异常,必要时恢复到原来的不变性条件
        //如果有return语句必须放在这里，原因已经说过了
    }finally{
        lock.unlock();
        //锁必须在finally块中释放
    }</code></pre>
<p>下面通过一个具体的例子演示如何使用可中断锁：</p>
<p>首先我们看看使用synchronized同步然后尝试进行中断的例子</p>
<pre><code>package com.rhwayfun.concurrency.r0405;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.concurrent.TimeUnit;

/**
 * Created by rhwayfun on 16-4-5.
 */
public class SyncInterruptDemo {

    //锁对象
    private static Object lock = new Object();
    //日期格式器
    private static DateFormat format = new SimpleDateFormat("HH:mm:ss");

    /**
     * 写数据
     */
    public void write(){
        synchronized (lock){
            System.out.println(Thread.currentThread().getName() + ":start writing data at " + format.format(new Date()));
            long start = System.currentTimeMillis();
            for (;;){
                //写15秒的数据
                if (System.currentTimeMillis() - start &gt; 1000 * 15){
                    break;
                }
            }
            //过了15秒才会运行到这里
            System.out.println(Thread.currentThread().getName() + ":finish writing data at " + format.format(new Date()));
        }
    }

    /**
     * 读数据
     */
    public void read(){
        synchronized (lock){
            System.out.println(Thread.currentThread().getName() + ":start reading data at "
                    + format.format(new Date()));
        }
    }

    /**
     * 执行写数据的线程
     */
    static class Writer implements Runnable{

        private SyncInterruptDemo syncInterruptDemo;

        public Writer(SyncInterruptDemo syncInterruptDemo) {
            this.syncInterruptDemo = syncInterruptDemo;
        }

        public void run() {
            syncInterruptDemo.write();
        }
    }

    /**
     * 执行读数据的线程
     */
    static class Reader implements Runnable{

        private SyncInterruptDemo syncInterruptDemo;

        public Reader(SyncInterruptDemo syncInterruptDemo) {
            this.syncInterruptDemo = syncInterruptDemo;
        }

        public void run() {
            syncInterruptDemo.read();
            System.out.println(Thread.currentThread().getName() + ":finish reading data at "
                    + format.format(new Date()));
        }
    }

    public static void main(String[] args) throws InterruptedException {

        SyncInterruptDemo syncInterruptDemo = new SyncInterruptDemo();

        Thread writer = new Thread(new Writer(syncInterruptDemo),"Writer");
        Thread reader = new Thread(new Reader(syncInterruptDemo),"Reader");

        writer.start();
        reader.start();

        //运行5秒，然后尝试中断读线程
        TimeUnit.SECONDS.sleep(5);
        System.out.println(reader.getName() +":I don‘t want to wait anymore at " + format.format(new Date()));
        //中断读的线程
        reader.interrupt();
    }
}
</code></pre>
<p>运行结果如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MDUxMzQxNTA5NjQ=.jpg"></p>
<p>从结果可以看到，尝试在读线程运行5秒后中断它，发现无果，因为写线程需要运行15秒，sleep5秒后过了10秒（sleep的5秒加上10刚好是写线程的15秒）读线程才显示中断的信息，意味着在写线程释放锁之后才响应了主线程的中断事件，也就是说在synchronized代码块运行期间不允许被中断，这点也验证了上面对synchronized的讨论。</p>
<p>然后我们使用ReentrantLock试一下，读线程能否正常响应中断，根据分析，在读线程运行5秒后，主线程中断读线程的时候读线程应该能够正常响应中断，然后停止执行读数据的操作。我们看看代码：</p>
<pre><code>package com.rhwayfun.concurrency.r0405;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

/**
 * Created by rhwayfun on 16-4-5.
 */
public class LockInterruptDemo {
    //锁对象
    private static Lock lock = new ReentrantLock();
    //日期格式器
    private static DateFormat format = new SimpleDateFormat("HH:mm:ss");

    /**
     * 写数据
     */
    public void write() {
        lock.lock();
        try {
            System.out.println(Thread.currentThread().getName() + ":start writing data at "
                    + format.format(new Date()));
            long start = System.currentTimeMillis();
            for (;;){
                if (System.currentTimeMillis() - start &gt; 1000 * 15){
                    break;
                }
            }
            System.out.println(Thread.currentThread().getName() + ":finish writing data at "
                    + format.format(new Date()));
        }finally {
            lock.unlock();
        }
    }

    /**
     * 读数据
     */
    public void read() throws InterruptedException {
        lock.lockInterruptibly();
        try {
            System.out.println(Thread.currentThread().getName() + ":start reading data at "
                    + format.format(new Date()));
        }finally {
            lock.unlock();
        }
    }

    /**
     * 执行写数据的线程
     */
    static class Writer implements Runnable {

        private LockInterruptDemo lockInterruptDemo;

        public Writer(LockInterruptDemo lockInterruptDemo) {
            this.lockInterruptDemo = lockInterruptDemo;
        }

        public void run() {
            lockInterruptDemo.write();
        }
    }

    /**
     * 执行读数据的线程
     */
    static class Reader implements Runnable {

        private LockInterruptDemo lockInterruptDemo;

        public Reader(LockInterruptDemo lockInterruptDemo) {
            this.lockInterruptDemo = lockInterruptDemo;
        }

        public void run() {
            try {
                lockInterruptDemo.read();
                System.out.println(Thread.currentThread().getName() + ":finish reading data at "
                        + format.format(new Date()));
            } catch (InterruptedException e) {
                System.out.println(Thread.currentThread().getName() + ": interrupt reading data at "
                        + format.format(new Date()));
            }
            System.out.println(Thread.currentThread().getName() + ":end reading data at "
                    + format.format(new Date()));
        }
    }

    public static void main(String[] args) throws InterruptedException {

        LockInterruptDemo lockInterruptDemo = new LockInterruptDemo();

        Thread writer = new Thread(new Writer(lockInterruptDemo), "Writer");
        Thread reader = new Thread(new Reader(lockInterruptDemo), "Reader");

        writer.start();
        reader.start();

        //运行5秒，然后尝试中断
        TimeUnit.SECONDS.sleep(5);
        System.out.println(reader.getName() + ":I don‘t want to wait anymore at " + format.format(new Date()));
        //中断读的线程
        reader.interrupt();
    }

}
</code></pre>
<p>运行结果如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MDUxMzQ4MTYwNDU=.jpg"></p>
<p>显然，读线程正常响应了我们的中断，因为读线程输出了中断信息，即使写线程写完数据后，读线程也没有输出结束读数据的信息，这点是在我们意料之中的。这样也验证了可中断锁的分析。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-10 03:33:50 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Java并发编程系列之十六：Lock锁的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEWbgx3.html" rel="bookmark">转：【Java并发编程】之十六：深入Java内存模型&mdash;&mdash;happen-before规则及其对DCL的分析（含代码）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/ns_code/article/details/17348313 happen-before规则介绍 Java语言中有一个&quot;先行发生&quot;(happen-before)的规则,它是Java内存模型中定义的两项操作之间的偏序关系,如果操作A先行发生于操作B,其意思就是说,在发生操作B之前,操作A产生的影响都能被操作B观察到,&quot;影响&quot;包括修改了内存中共享变量的值.发送了消息.调用了方法等,它与时间上的先后发生基本没有			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Myz9Km0.html" rel="bookmark">【Java并发编程】之十六：深入Java内存模型&mdash;&mdash;happen-before规则及其对DCL的分析（含代码）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				happen-before规则介绍 Java语言中有一个&quot;先行发生&quot;(happen-before)的规则,它是Java内存模型中定义的两项操作之间的偏序关系,如果操作A先行发生于操作B,其意思就是说,在发生操作B之前,操作A产生的影响都能被操作B观察到,&quot;影响&quot;包括修改了内存中共享变量的值.发送了消息.调用了方法等,它与时间上的先后发生基本没有太大关系.这个原则特别重要,它是判断数据是否存在竞争.线程是否安全的主要依据. 举例来说,假设存在如下三个线程,分别执行对应			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qEvxD3.html" rel="bookmark">Java并发编程系列之十五：Executor框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java使用线程完成异步任务是很普遍的事,而线程的创建与销毁需要一定的开销,如果每个任务都需要创建一个线程将会消耗大量的计算资源,JDK 5之后把工作单元和执行机制区分开了,工作单元包括Runnable和Callable,而执行机制则由Executor框架提供.Executor框架为线程的启动.执行和关闭提供了便利,底层使用线程池实现.使用Executor框架管理线程的好处在于简化管理.提高效率,还能避免this逃逸问题--是指不完整的对象被线程调用. Executor框架使用了两级调度模型进行			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Z27zG3.html" rel="bookmark">Java并发编程系列（三）-locks锁机制类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java中的锁可以分为&quot;同步锁&quot;和JUC包里面的锁(locks包) 同步锁:即通过synchronized关键字来进行同步,实现对竞争资源的互斥访问的锁.Java 1.0版本中就已经支持同步锁了.同步锁的原理是,对于每一个对象,有且仅有一个同步锁:不同的线程能共同访问该同步锁.但是,在同一个时间点,该同步锁能且只能被一个线程获取到.这样,获取到同步锁的线程就能进行CPU调度,从而在CPU上执行:而没有获取到同步锁的线程,必须进行等待,直到获取到同步锁之后才能继续运行. locks包:相			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MggwB8M.html" rel="bookmark">JAVA 并发编程-线程同步通信技术（Lock和Condition）（十）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在之前的博客中已经介绍过线程同步通信技术&lt;JAVA 并发编程-传统线程同步通信技术(四)&gt;,上篇是使用的synchronized,wait,notify来实现,今天我们使用的是Lock和Condition,下面我们结合两者对比来学习. 简单的Lock锁应用: /** * 简单Lock的应用 * @author hejingyuan * */ public class LockTest { public static void main(String[] args) { new LockTest			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGdqjo0.html" rel="bookmark">转： 【Java并发编程】之十八：第五篇中volatile意外问题的正确分析解答（含代码）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/ns_code/article/details/17382679 在&lt;Java并发编程学习笔记之五:volatile变量修饰符-意料之外的问题&gt;一文中遗留了一个问题,就是volatile只修饰了missedIt变量,而没修饰value变量,但是在线程读取value的值的时候,也读到的是最新的数据.但是在网上查了很多资料都无果,看来很多人对volatile的规则并不是太清晰,或者说只停留在很表面的层次,一知半解. 这两天看&lt;深入Ja			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzbvBqM.html" rel="bookmark">Java并发编程系列&lpar;一&rpar;-线程的基本使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近在学习java并发编程基础.一切从简,以能理解概念为主. 并发编程肯定绕不过线程.这是最基础的. 那么就从在java中,如何使用线程开始. 继承Thread类 继承Thread类,重写run方法,new出对象,调用start方法. 在新启的线程里运行的就是重写的run方法. 1 /** 2 * 集成Thread类 实现run() 3 */ 4 public class C1 extends Thread { 5 6 @Override 7 public void run() { 8 try			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pbYNw0.html" rel="bookmark">java并发编程系列一、多线程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.什么是线程 线程是CPU独立运行和独立调度的基本单位: 2.什么是进程 进程是资源分配的基本单位: 3.线程的状态 新创建   线程被创建,但是没有调用start方法 可运行(RUNNABLE)  运行状态,由cpu决定是不是正在运行 被阻塞(BLOCKING)  阻塞,线程被阻塞于锁 等待/计时等待(WAITING) 等待某些条件成熟 被终止  线程执行完毕 线程的生命周期及五种基本状态: 4.线程的优先级 成员变量priority控制优先级,范围1-10之间,数字越高优先级越高,缺省为5			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBm6qj4.html" rel="bookmark">《Java并发编程实战》第六章 任务运行 读书笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. 在线程中运行任务 无限制创建线程的不足 .线程生命周期的开销很高 .资源消耗 .稳定性 二.Executor框架 Executor基于生产者-消费者模式,提交任务的操作相当于生产者.运行任务的线程则相当于消费者. 1. Executors 返回 ExecutorService 2. ExecutorService方法submit.execute 3. ExecutorService.submit 返回 Future 线程池,Executors方法介绍 方法名 解释 newFixedThre			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j35X510.html" rel="bookmark" class="title">洛谷 P2801 教主的魔法 题解</a>
					<div>
						此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:https://www.luogu.org/problem/show?pid=2801 题目描述 教主最近学会了一种神奇 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jyYO7M.html" rel="bookmark" class="title">Unity&plus;NGUI性能优化方法总结</a>
					<div>
						一共9招. 1 资源分离打包与加载 游戏中会有很多地方使用同一份资源.比如,有些界面会共用同一份字体.同一张图集,有些场景会共用同一张贴图,有些会怪物使用同一个Animator,等等.可以在制作游戏安 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jyPg7M.html" rel="bookmark" class="title">iOS开发系列--绘图与滤镜全面解析</a>
					<div>
						概述 在iOS中可以很容易的开发出绚丽的界面效果,一方面得益于成功系统的设计,另一方面得益于它强大的开发框架.今天我们将围绕iOS中两大图形.图形绘图框架进行介绍:Quartz 2D绘制2D图形和Co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmGpvQ3.html" rel="bookmark" class="title">ng 依赖注入</a>
					<div>
						将依赖的对象注入到当前对象,直接去使用依赖的对象即可. 降低耦合度.提高开发速度.. 文件压缩:yui-compressor有两种方案:①CLI(command line interface)java ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgXl8R0.html" rel="bookmark" class="title">澳大利亚高等法院首位女性首席大法官宣誓就职s4</a>
					<div>
						万萍(女)    王利民    王明兴    尹玉林    龙亮    龙石佑    龙训锋 红网长沙1月8日讯(通讯员 聂琴 潇湘晨报记者 殷建军)如果让小学生互相写期末评语会怎么样?这是长沙麓山国 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dxJkz0.html" rel="bookmark" class="title">1231递归下降语法分析程序设计</a>
					<div>
						#include&lt;stdio.h&gt; #include&lt;string&gt; char str[10]; //记录要分析的字符串 int x=0; //记录第一个字符 void E() ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVYx9z4.html" rel="bookmark" class="title">centos中如何查看机器型号</a>
					<div>
						centos中使用如下命令可查看机器型号: dmidecode |grep &quot;Product Name&quot; centos中如何查看机器型号,布布扣,bubuko.com					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47qd7o0.html" rel="bookmark" class="title">jQuery&period;stickUp插件重构</a>
					<div>
						stickUp插件用于实现固定菜单栏效果,原理很简单,说白了就是监听document的scroll事件,滚动到特定值时,将特定元素的position设置为fixed,核心代码如下: 1 $(docum ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLWgXB4.html" rel="bookmark" class="title">centos   LB负载均衡集群   第三十三节课</a>
					<div>
						centos   LB负载均衡集群   第三十三节课 上半节课 下半节课 f					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXL1OwM.html" rel="bookmark" class="title">java 获取服务器时间同步本地计算机时间</a>
					<div>
						http://hi.baidu.com/captives/item/25c8b80170a9b0ccf45ba6f8 ----------------------------------------- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38wAGy0.html" rel="bookmark" class="title">&lbrack;OSI&rsqb;网络7层模型的理解</a>
					<div>
						应用层:HTTP 应用层 表现层:编码 表现层 会话层:端口 会话层 传输层:TCP/UDP 协议 传输层 网络层:IP 标记  +-- 网络层 --+  网络层 数据链路层:计算机Mac地址标记 | ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qElEP3.html" rel="bookmark" class="title">又开始做物联网项目</a>
					<div>
						研究生时候一直在物联网项目,毕业后就一直没有再做这方面了,知道最近,又开始做物联网项目了,3年没做,出了很多新的技术,新的标准,让我有点赶不上,以前学的也有点忘了,不过花点时间看看应该很快可以捡起来吧 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49LL8g3.html" rel="bookmark" class="title">date和clock详解</a>
					<div>
						date: 时间管理 date:系统时间clock:硬件时间 date: +%D,以月日年(%m%d%)的格式显示时间 +%Y, 显示年份 +%y, 只显示两位的年份 +%d, 显示日期 (所有这些选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lkvWLM.html" rel="bookmark" class="title">选择 &lpar;动态树&rpar;</a>
					<div>
						题目描述: 现在,我想知道自己是否还有选择. 给定n个点m条边的无向图以及顺序发生的q个事件. 每个事件都属于下面两种之一: 1.删除某一条图上仍存在的边 2.询问是否存在两条边不相交的路径可以从点u ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vz87L3.html" rel="bookmark" class="title">c语言中递归函数真的好吗？</a>
					<div>
						递归函数就是直接或者间接的调用自己本身的函数. 接触递归的时候我们经常会看到这个程序 #include&lt;stdio.h&gt; #include&lt;stdlib.h&gt; long fac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41Dveq3.html" rel="bookmark" class="title">qt5&period;4</a>
					<div>
						rm -f libQt5Qml.so.5.4.0 libQt5Qml.so libQt5Qml.so.5 libQt5Qml.so.5.4g++ -Wl,-O1,--sort-common,--as- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k91nP4.html" rel="bookmark" class="title">由企业邮箱培训引发的一些小思考</a>
					<div>
						我公司之所以打造好邮网这么个平台,是缘于团队在企业邮箱这个行业的多年积累和沉淀,希望通过这些优势,能从比较中立的角度,帮助客户挑选最为合适的邮箱产品.因此整合了多个企业邮箱系统的优势品牌.这也让我们有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xaogj3.html" rel="bookmark" class="title">【VC编程技巧】控件&quest;4&period;1位图Button</a>
					<div>
						4.1位图Button 给按钮增加位图,或改变按钮字体,可以让按钮达到跟炫的效果:如何给按钮增加位图,和改变按钮上文字的字体?请看下面示例! 1&gt;创建对话框程序,建立如下对话框: 图1 资源ID ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME6v8X0.html" rel="bookmark" class="title">点燃运动激情 放飞水利梦想 水利部直属机关第九届职工运动会在京举行</a>
					<div>
						本站讯 金风送爽,丹桂飘香.在举国上下庆祝新中国成立67周年.纪念中国工农红军长征胜利80周年之际,水利部直属机关第九届职工运动会近日在北京宣武体育场隆重举行.水利部党组书记.部长陈雷宣布运动会开幕并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyBPWp0.html" rel="bookmark" class="title">【转】【涨姿势】支付宝怎么做风险控制？</a>
					<div>
						作为一款实名用户数超过3亿.单天交易笔数能够达到1.97亿的交易工具,支付宝是靠什么来保障账户的安全. 首先,支付宝密码都是怎么丢失的? 最大的丢失来源是扫号,你在别的网站账号密码丢失后,被用来登陆支 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
